#include "file_choose.h"

#include "assets/overlays/ovl_File_Choose/ovl_file_choose.h"

s16 D_808123F0[] = {
    0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F, 0x0010, 0x0011, 0x0012, 0x0013, 0x0014, 0x0015, 0x0016,
    0x0017, 0x0018, 0x0019, 0x001A, 0x001B, 0x001C, 0x001D, 0x001E, 0x001F, 0x0020, 0x0021, 0x0022, 0x0023,
    0x0024, 0x0025, 0x0026, 0x0027, 0x0028, 0x0029, 0x002A, 0x002B, 0x002C, 0x002D, 0x002E, 0x002F, 0x0030,
    0x0031, 0x0032, 0x0033, 0x0034, 0x0035, 0x0036, 0x0037, 0x0038, 0x0039, 0x003A, 0x003B, 0x003C, 0x003D,
    0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007, 0x0008, 0x0009, 0x0000, 0x0040, 0x003F, 0x003E,
};

// #region SOH [NTSC]
// clang-format off
s16 gKeyboardCharactersHiragana[] = {
    //            'あ'  'か'  'さ'  'た'  'な'   'は'  'ま'  'や'  'ら'  'わ'   'ぁ'  'ゃ'  'っ'
    /* Row 0 */ 0x0A, 0x0F, 0x14, 0x19, 0x1E, 0x23, 0x28, 0x2D, 0x30, 0x35, 0x38, 0x3E, 0x3D,
    //            'い'  'き'  'し'  'ち'  'に'   'ひ'  'み'  '  '  'り'  ' '   'ぃ'  '  '  '  ' 
    /* Row 1 */ 0x0B, 0x10, 0x15, 0x1A, 0x1F, 0x24, 0x29, 0xDF, 0x31, 0xDF, 0x39, 0xDF, 0xDF,
    //            'う'  'く'  'す'  'つ'  'ぬ'   'ふ'  'む'  'ゆ'  'る'  'を'   'ぅ'  'ゅ'  'ー' 
    /* Row 2 */ 0x0C, 0x11, 0x16, 0x1B, 0x20, 0x25, 0x2A, 0x2E, 0x32, 0x36, 0x3A, 0x3F, 0xE4,
    //            'え'  'け'  'せ'  'て'  'ね'   'へ'  'め'  '  '  'れ'  ' '   'ぇ'  '  '  '゛' 
    /* Row 3 */ 0x0D, 0x12, 0x17, 0x1C, 0x21, 0x26, 0x2B, 0xDF, 0x33, 0xDF, 0x3B, 0xDF, 0xE7,
    //            'お'  'こ'  'そ'  'と'  'の'   'ほ'  'も'  'よ'  'ろ'  'ん'   'ぉ'  'ょ'  '゜' 
    /* Row 4 */ 0x0E, 0x13, 0x18, 0x1D, 0x22, 0x27, 0x2C, 0x2F, 0x34, 0x37, 0x3C, 0x40, 0xE8, 
};

s16 gKeyboardCharactersKatakana[] = {
    //            'ア'  'カ'  'サ'  'タ'  'ナ'   'ハ'   'マ'  'ヤ'  'ラ'  'ワ'   'ァ'  'ャ'  'ッ'
    /* Row 0 */ 0x5A, 0x5F, 0x64, 0x69, 0x6E, 0x73, 0x78, 0x7D, 0x80, 0x85, 0x88, 0x8E, 0x8D,
    //            'イ'  'キ'  'シ'  'チ'  'ニ'   'ヒ'   'ミ'  '  '  'リ'  ' '   'ィ'  '  '  '  ' 
    /* Row 1 */ 0x5B, 0x60, 0x65, 0x6A, 0x6F, 0x74, 0x79, 0xDF, 0x81, 0xDF, 0x89, 0xDF, 0xDF,
    //            'ウ'  'ク'  'ス'  'ツ'  'ヌ'   'フ'   'ム'  'ユ'  'ル'  'ヲ'   'ゥ'  'ュ'  'ー' 
    /* Row 2 */ 0x5C, 0x61, 0x66, 0x6B, 0x70, 0x75, 0x7A, 0x7E, 0x82, 0x86, 0x8A, 0x8F, 0xE4,
    //            'エ'  'ケ'  'セ'  'テ'  'ネ'   'ヘ'   'メ'  '  '  'レ'  ' '   'ェ'  '  '  '゛' 
    /* Row 3 */ 0x5D, 0x62, 0x67, 0x6C, 0x71, 0x76, 0x7B, 0xDF, 0x83, 0xDF, 0x8B, 0xDF, 0xE7,
    //            'オ'  'コ'  'ソ'  'ト'  'ノ'   'ホ'   'モ'  'ヨ'  'ロ'  'ン'   'ォ'  'ョ'  '゜' 
    /* Row 4 */ 0x5E, 0x63, 0x68, 0x6D, 0x72, 0x77, 0x7C, 0x7F, 0x84, 0x87, 0x8C, 0x90, 0xE8, 
};

s16 gKeyboardCharactersAlphanumeric[] = {
    //            'A'   'B'   'C'   'D'   'E'   'F'   'G'   'H'   'I'   'J'   'K'   'L'   'M'
    /* Row 0 */ 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5, 0xB6, 0xB7, 
    //            'N'   'O'   'P'   'Q'   'R'   'S'   'T'   'U'   'V'   'W'   'X'   'Y'   'Z'
    /* Row 1 */ 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0xBE, 0xBF, 0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 
    //            'a'   'b'   'c'   'd'   'e'   'f'   'g'   'h'   'i'   'j'   'k'   'l'   'm'
    /* Row 2 */ 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0xD1, 
    //            'n'   'o'   'p'   'q'   'r'   's'   't'   'u'   'v'   'w'   'x'   'y'   'z'
    /* Row 3 */ 0xD2, 0xD3, 0xD4, 0xD5, 0xD6, 0xD7, 0xD8, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 
    //            '1'   '2'   '3'   '4'   '5'   '6'   '7'   '8'   '9'   '0'   '.'   '-'   ' '
    /* Row 4 */ 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x00, 0xEA, 0xE4, 0xDF, 
};
// clang-format on

s16 D_808127DC_ne0[] = { 0, 1, 2, 1, 0, 2, 0, 2, 1, 0 };

// #endregion
